// placeByContext.jsx
// © Gerald Singelmann, 09/2008
// Dateien platzieren per Kontextmenu. 
//
// Versucht, die ausgewählte Datei auf das markierte Objekt zu platzieren. 
// Funktioniert auch mit mehreren ausgewählten Objekten bzw. mehreren Dateien
//
// Gebrauch wie immer auf eigene Gefahr, 
// wir können nicht garantieren, dass das Script nicht mal unerwartete Ergebnisse erzeugt
// 
#targetengine "session" 
ContextPlace(); 
function ContextPlace(){ 
	var myLayoutContextMenu = app.menus.item("$ID/RtMouseLayout"); 
	var myTextContextMenu = app.menus.item("$ID/RtMouseText"); 

	try{ 
		var myPlaceAction = app.scriptMenuActions.item("Platzieren ..."); 
		myPlaceAction.name; 
//		$.writeln("Action exists");
	} 
	catch(myError){
		var myPlaceAction = app.scriptMenuActions.add("Platzieren ..."); 
//		$.writeln("Action created");
	} 
	var myEventListener = myPlaceAction.eventListeners.add("onInvoke", myPlaceHandler, false); 

	var myLSep = myLayoutContextMenu.menuSeparators.add();
	var myTSep = myTextContextMenu.menuSeparators.add();
	var myLPlaceMenuItem = myLayoutContextMenu.menuItems.add(myPlaceAction); 
	var myTPlaceMenuItem = myTextContextMenu.menuItems.add(myPlaceAction); 

	function myPlaceHandler(myEvent){ 
//		$.writeln("do something");
//-----------------------
		var nSel = app.selection.length;
		var myFiles = File.openDialog ("Welche Dateien sollen platziert werden...", undefined, true);
		if (myFiles == null) {return}
		var nFiles = myFiles.length;
		
		if (nSel == 1 && nFiles > 1) {
			switch(app.selection[0].constructor.name) {
				case "Rectangle": 
				case "Oval": 
				case "Polygon": 
				case "TextFrame": 
					var myGrid = splitThing(app.selection[0], nFiles);
					for (var n = 0; n < Math.min(myGrid.length, nFiles); n++) {
						try {
							myGrid[n].place(myFiles[n]);
						} catch(e) {}
					}
					app.select(myGrid);
					break;
				default:
					app.place(myFiles);
			}
		} else if (nSel > 1 && nFiles == 1) {
			for (var n = 0; n < nSel; n++) {
				try {
					app.selection[n].place(myFiles[0]);
				} catch(e) {}
			}
		} else {		
			var bDone = false;
			var nS = 0;
			var nF = 0;		
			while (!bDone) {
				try {
					app.selection[nS].place(myFiles[nF])
					nS++;
					nF++;
				} catch(e) {
					try {
						app.place(myFiles[nF]);
						nS++;
						nF++;
					} catch (e1) { nF++; }
				}
				if (nF == nFiles) { bDone = true}
				if (nS == nSel) {
					bDone = true;
					for (var n = nF ; n < nFiles; n++) {
						try {
							app.place(myFiles[n]);
						} catch(e) {}
					}
				}
			}
		}

		function splitThing(aThing, nFiles){
			var nEdge = Math.ceil( Math.sqrt(nFiles) );
			
			var myLabelWidth = 90;
			var myDialog = app.dialogs.add({name:"Raster erstellen"});
			with(myDialog.dialogColumns.add()){
				with(dialogRows.add()){
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"Zu platzierende Dateien: "+ nFiles.toString()});
					}
				}
				with(dialogRows.add()){
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"Zeilen:", minWidth:myLabelWidth});
						staticTexts.add({staticLabel:"Spalten:", minWidth:myLabelWidth});
					}
					with(dialogColumns.add()){
						var myNumberOfRowsField = integerEditboxes.add({editValue: nEdge});
						var myNumberOfColumnsField = integerEditboxes.add({editValue: nEdge});
					}
				}
				with(dialogRows.add()){
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"Zeilenabstand:", minWidth:myLabelWidth});
					}
					with(dialogColumns.add()){
						var myRowGutterField = measurementEditboxes.add({editValue:3 * 2.83465 , editUnits:MeasurementUnits.millimeters});
					}
				}
				with(dialogRows.add()){
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"Spaltenabstand:", minWidth:myLabelWidth});
					}
					with(dialogColumns.add()){
						var myColumnGutterField = measurementEditboxes.add({editValue:3 * 2.83465 , editUnits:MeasurementUnits.millimeters});
					}
				}
			}
			var myResult = myDialog.show();
			if(myResult == true){
				var nRows = myNumberOfRowsField.editValue;
				var nCols = myNumberOfColumnsField.editValue;
				var myRowGutter = myRowGutterField.editValue;
				var myColumnGutter = myColumnGutterField.editValue;
				myDialog.destroy();
				
				var myOldXUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
				var myOldYUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
				app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
				app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;

				var myX1, myY1, myX2, myY2, nuObject;
				var nuObjects = new Array();
				var myBounds = aThing.geometricBounds;
				var myWidth = myBounds[3]-myBounds[1];
				var myHeight =  myBounds[2]-myBounds[0];
				
				if (myRowGutter * (nRows - 1) > myHeight) { myRowGutter = 0 }
				if (myColumnGutter * (nCols - 1) > myWidth) { myColumnGutter = 0 }

				var myColumnWidth = (myWidth - (myColumnGutter * (nCols - 1)))/nCols;
				var myRowHeight =  (myHeight - (myRowGutter * (nRows - 1)))/nRows;
				for(var nRow = 0; nRow < nRows; nRow++){
					myY1 = myBounds[0]+(myRowHeight*nRow)+(myRowGutter*nRow);
					myY2 = myY1 + myRowHeight;
					for(var nCol = 0; nCol < nCols; nCol++){
						myX1 = myBounds[1]+(myColumnWidth*nCol)+(myColumnGutter*nCol);
						myX2 = myX1 + myColumnWidth;
						nuObject = aThing.duplicate();
						nuObject.geometricBounds = [myY1, myX1, myY2, myX2];
						nuObjects.push(nuObject);
					}
				}
				aThing.remove();

				app.activeDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
				app.activeDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
				
				return nuObjects;
			}
			else{
				myDialog.destroy();
				return -1;
			}
		}
//-----------------------
	}
}